<template>
  <div id="cascaderMap">
    <span class="buildFloor" style="padding-right: 12px;">设备族</span>
    <el-select v-model="value" placeholder="请选择" clearable :props="props" filterable :style="isWidth ? '' : 'width:160px;'" size="small" @change="changeVal">
      <el-option  v-for="item in options" :key="item.code" :label="item.facility" :value="item.code"></el-option>
    </el-select>
    <!-- <el-cascader
      placeholder="请选择"
      :options="options"
      v-model="value"
      :props="props"
      filterable
      :style="isWidth ? '' : 'width:160px;'"
      size="small"
      @change="changeVal"
      change-on-select
    ></el-cascader> -->
  </div>
</template>
<script>
import {mapGetters} from 'vuex';
import { getEquipBelongs, queryProperty } from "@/api/scan/request";
export default {
  name: "getCode",
  props: {
    isWidth: {
      type: Boolean,
      default: true
    },
    all: {
      type: Boolean,
      default: false,
    }
  },
  computed: {
    ...mapGetters("layout", [
        "projectId",
    ])
  },
  data() {
    return {
      value: [],
      options: [],
      props: {
        value: "code",
        label: "facility"
      },
      falg: true,
      content: []
    };
  },
  created() {
    this.getData();
  },
    watch: {
      projectId() {
          this.value = ['']
      }
  },
  methods: {
    setValue(val) {
      this.value = val
    },
    //修改val
    changeVal(val) {
      let value = {}
      this.options.map(item => {
        if (item.code == val) {
          value = item
        }
      })
      this.value = val
      this.$emit("change", value)
    },
    getData() {
      let param1 = {
        data:{
          Distinct: true,
          PageNumber: 1,
          PageSize: 500,
          Projection:["Family","FamilyName"]
        }
      }, param2 = {
        Distinct: true,
        PageNumber: 1,
        PageSize: 500,
        Projection: [
          "Family"
        ]
      }
      let promise1 = new Promise((resolve, reject) => {
        getEquipBelongs(param1, res => {
          resolve(res)
        })
      })
      let promise2 = new Promise((resolve, reject) => {
        queryProperty(param2, res => {
          resolve(res)
        })
      })
      Promise.all([promise1,promise2]).then((res) => {
        let allData = res[0], data = res[1]
        this.options = this.changeArr(allData.Content)
        if (this.value) {
          this.changeVal(this.value)
        }
        if(!this.all) {
          this.content = data.Content.map(item => {
            return item.Family
          });
          this.changeList();
          if (this.value) {
            this.changeVal(this.value)
          }
        }
      })
      // getEquipBelongs(params, res => {
      //   this.options = this.changeArr(res.Content)
      //   if (!!this.value && this.value.length) {
      //     let value = {}
      //     this.options.map(item => {
      //       if (item.code == this.value[0]) {
      //         value = item
      //       }
      //     })
      //     this.$emit("change", value)
      //   }
      //   if (!this.falg) {
      //     this.changeList()
      //   }
      // })
    },
    changeArr(arr) {
      let data = [];
      arr.map(item => {
        data.push({ code: item.Family, facility: item.FamilyName, disabled: false })
      });
      return data;
    },
    pushData(content) {
      this.content = content
      if (this.options.length) {
        this.falg = true
        this.changeList()
      } else {
        this.falg = false
      }
    },
    changeList() {
      this.options = this.options.filter(item => {
        if (this.content.indexOf(item.code) > -1) {
          return item
        }
      })
    }
  }
};
</script>
<style lang="less" scoped>
#cascaderMap {
  float: left;
  margin-left: 10px;
  .buildFloor {
    color: #999999;
    font-size: 14px;
  }
}
</style>
